<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Material } from '@/types/Material'
import { useStockStore } from '@/stores/stock'
import { useRoute } from 'vue-router'
import { useTypeStore } from '@/stores/type'
import { useOrderStore } from '@/stores/order'
import router from '@/router'

const route = useRoute()
const stockStore = useStockStore()
const orderStore = useOrderStore()
const materialTypeStore = useTypeStore()
const headers = [
    {
      title: 'Id',
      key: 'id'
    },
    {
      title: 'Name',
      key: 'name'
    },
    {
      title: 'Price',
      key: 'price'
    },
    {
      title: 'Unit',
      key: 'unit'
    },
    {
      title: 'Minimum',
      key: 'minimum'
    },
    {
      title: 'Type',
      key: 'types',
      value: (item: any | Material) => item.type.name
    },
    { title: 'Actions', key: 'actions', sortable: false }
]

const search = ref('')

const dialogDelete = ref(false)
const dialog = ref(false)
const form = ref(false)
const refform = ref<VForm | null>(null)
const loading = ref(false)

function pushOrder(){
  router.push({ path: '/OrderStock' });
  stockStore.closeLowMat()
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    stockStore.clearForm()
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  closeDialog()
  await stockStore.saveMaterial()
}

async function editItem(item: Material) {
  if (!item.id) return
  console.log(item)
  await stockStore.getMaterial(item.id)
  dialog.value = true
}

async function deleteItem(item: Material) {
  if (!item.id) return
  await stockStore.getMaterial(item.id)
  dialogDelete.value = true
}

async function deleteItemConfirm() {
  await stockStore.deleteMaterial()
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    stockStore.clearForm()
  })
}

onMounted(async () => {
  await stockStore.getMaterials()
  await materialTypeStore.getTypes()
  stockStore.checkLowStock()
})
</script>

<template>
  <v-toolbar flat style="background-color: #212121; color: white">
    <v-toolbar-title>Stock Management</v-toolbar-title>
    <v-spacer></v-spacer>

    <v-text-field
      v-model="search"
      prepend-inner-icon="mdi-magnify"
      density="compact"
      label="Search"
      single-line
      flat
      hide-details
      variant="solo-filled"
      style="width: 1px"
    ></v-text-field>

    <!-- Put Dialog -->
    <v-menu transition="slide-y-transition">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" icon style="background-color: #212121" color="white">
          <v-icon>mdi-dots-vertical</v-icon>
        </v-btn>
      </template>
      <v-list>
        <v-list-item>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="CheckStock"
              :class="{ active: route.name === 'checkstock' }"
              :to="{ path: '/CheckStock' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-package-check</v-icon>
              CheckStock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="OrderStock"
              :class="{ active: route.name === 'orderstock' }"
              :to="{ path: '/OrderStock' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-truck-delivery</v-icon>
              OrderStock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="HistoryStock"
              :class="{ active: route.name === 'history' }"
              :to="{ path: '/History' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-history</v-icon>
              HistoryStock
            </v-btn>
          </v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>
    <!--Delete Dialog-->
    <v-dialog v-model="dialogDelete" width="500px">
      <v-card>
        <br />
        <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
        <v-spacer></v-spacer>
        <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
        <v-card-title align="center" class="text-h10">
          This action cannot be undone.<br />
          All values associated with this field will be lost.
        </v-card-title>
        <v-spacer></v-spacer>
        <div align="center">
          <div style="margin: 0 auto; max-width: 400px">
            <v-btn
              block
              style="background-color: #e11d48"
              color="white"
              variant="text"
              @click="deleteItemConfirm()"
            >
              Delete field
            </v-btn>
          </div>
        </div>
        <div align="center">
          <div
            style="
              margin: 0 auto;
              max-width: 400px;
              border: 1px solid #dfe1e6;
              border-radius: 5px;
              margin-top: 10px;
            "
          >
            <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
          </div>
        </div>
        <v-spacer></v-spacer>
        <br />
      </v-card>
    </v-dialog>
  </v-toolbar>
  <div>
    <v-data-table v-model:search="search" :headers="headers" :items="stockStore.materials">
      <template v-slot:top> </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
    <div class="floating-button">
      <v-btn
        color="red"
        width="60"
        height="60"
        rounded
        @click="stockStore.lowStockDialog()"
      >
        <v-icon size="25">mdi-package-down</v-icon>
        {{ stockStore.lowMaterial.length }}
        <div style="font-size: 10px"></div>
      </v-btn>
    </div>
    <v-row>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col>
        <v-dialog v-model="dialog" persistent width="600">
          <template v-slot:activator="{ props }">
            <v-btn v-bind="props" style="background-color: #c7a17a; color: white">
              New Material
            </v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="text-h5">Material</span>
            </v-card-title>
            <v-card-text>
              <v-form ref="refform" v-model="form" @submit.prevent="stockStore.onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="12" md="12">
                      <v-text-field
                        v-model="stockStore.editedMaterial.name"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Name"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="12" md="6">
                      <v-text-field
                        v-model="stockStore.editedMaterial.price"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        clearable
                        label="Price"
                        placeholder="Enter Price"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="12" md="6">
                      <v-text-field
                        v-model="stockStore.editedMaterial.minimum"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Minimum"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6" md="4">
                      <v-combobox
                        v-model="stockStore.editedMaterial.type"
                        :items="materialTypeStore.types"
                        item-title="name"
                        item-value="id"
                        label="Select Types of Material"
                        :return-object="true"
                      ></v-combobox>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
              <small>*indicates required field</small>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
              <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <!-- Low Material -->
        <v-dialog v-model="stockStore.dialogLowStock" persistent width="750">
          <v-card>
            <v-card-title style="background-color: #eae7de;">
              <span class="text-h5">Low Material!</span>
            </v-card-title>
            <v-data-table :headers="headers" :items="stockStore.lowMaterial" style="background-color: #eae7de;">
              <template v-slot:top> </template>
              <template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" class="me-2" @click="orderStore.addOrderReceipt(item), pushOrder()" >
                   mdi-cart 
                </v-icon>
              </template>
            </v-data-table>
            <v-card-actions style="background-color: #eae7de;">
              <v-spacer></v-spacer>
              <v-btn color="primary" variant="text" @click="stockStore.closeLowMat()"> Close </v-btn>
              <v-btn color="primary" variant="text" @click="pushOrder()"> Order </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>

      </v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
    </v-row>
  </div>
</template>

<style scoped>
.floating-button {
  position: fixed;
  bottom: 30px;
  right: 30px;
  z-index: 1000;
}
</style>
